<form [formGroup]="testForm" (ngSubmit)="onSubmit(testForm.value)">
  <ng-container *ngFor="let detail of formDetails">
  <label> {{detail.label}} 
    <input type="{{detail.type}}" formControlName="{{detail.property}}">
  </label>
</ng-container>
    <button type="submit">Submit</button>
</form>